<?php
namespace Models;
use Mike42\Escpos\PrintConnectors\FilePrintConnector;
use Mike42\Escpos\PrintConnectors\NetworkPrintConnector;
use Mike42\Escpos\PrintConnectors\WindowsPrintConnector;
use Mike42\Escpos\Printer;

class escpos_Fr_php {
	public $f3, $sets, $config, $connector, $printer, $check_sum;
	
	function __construct($f3, $sets, $config) {
		$this->f3=$f3;
		$this->sets=$sets;
		//$this->config=parse_ini_file($sets['driver'].'/server.config'); // Настройки драйвера
		$this->config=$config;
		spl_autoload_register(function ($class_name) {
    		require_once('src/'.str_replace('\\', '/', $class_name).'.php');
		});
	}

	function printer_connect() {
		$this->config['PortType']=mb_strtolower($this->config['PortType']);
		if($this->config['PortType']=='local') {
			return $connector = new FilePrintConnector($this->sets['url']);
		}
		elseif($this->config['PortType']=='remote') {
			$u=mb_substr($this->sets['url'], mb_strrpos($this->sets['url'], '/')+1);
			$url=explode(':', $u);
			$host = $url[0];
			$port = $url[1];
			return $connector = new NetworkPrintConnector($url[0], $url[1]);
		}
		elseif($this->config['PortType']=='windowsusb') {
			return $connector = new WindowsPrintConnector($this->sets['url']);
		}
		echo '<p class="false">Невозможно установить соединение</p>';
		exit();
	}

	function kkm_init() {
		if(isset($this->config['Exec'])) {
            foreach ($this->config['Exec'] as $cmd) {
                if($cmd!='') {
                    exec($cmd);
                }
            }
        }
        if(isset($this->config['Send'])) {
        	$connector = $this->printer_connect();
			$this->printer = new Printer($connector);
            foreach ($this->config['Send'] as $cmd) {
                if(!$cmd) continue;
                $p=explode(';', $cmd);
                if(count($p)>1) {
                	$connector->write(Printer::ESC .$p[0]. chr($p[1]));
                }
                else {
                	$connector->write(pack('H*', $cmd));
                }
            }
            $this->printer->close();
        }
       	$this->f3->set('SESSION.'.$this->sets['printer'].'_drivers_init', 1);
	}

	// Форматирование текста
	function text_format($s, $w=48) {
        $s=str_replace('#kkm_bold#', '', $s);
        // Заменяем #kkm_right# на пробелы
        $kkm_right="#kkm_right#"; # тэг сдвига вправо
        $space_n=$w-(mb_strlen($s)-mb_strlen($kkm_right)); // кол-во пробелов
        if($space_n>0) {
        	$s=str_replace($kkm_right, str_repeat(" ", $space_n), $s); // заменяем тэг сдвига на пробелы
        }

        // Заменяем #kkm_center# на пробелы
        $kkm_center="#kkm_center#"; // тэг сдвига в центр
        $space_n=floor(($w-(mb_strlen($s)-mb_strlen($kkm_center)))/2); // кол-во пробелов
        if($space_n>0) {
        	$s=str_replace($kkm_center, str_repeat(" ", $space_n), $s); // заменяем тэг сдвига на пробелы
        }
        return $s;
    }

	// Что нужно выполнить
	function wtf($s) {
		$s=trim($s);
        $p=explode(';', $s);
        $n=count($p);
        if($p[$n-1]=='') {
            unset($p[$n-1]);
            $n-=1;
        }
		if($p[0]=='p' || $p[0]=='pm') { // Печать строки или строк
			$this->p($p[1]);
		}
		elseif($p[0]=='print_bold') { // Печать жирным
			$this->print_bold($p[1]);
		}
		elseif($p[0]=='print_font') { // Печать заданным шрифтом
			$this->print_font($p[1], $p[2]);
		}
		elseif($p[0]=='feed') { // Протяжка
			$this->printer->feed($p[1]);
		}
		elseif($p[0]=='beep') { // Гудок, наверное
			$this->printer->pulse();
		}
		elseif($p[0]=='cut_check') { // Отрезка
			$this->printer->cut();
		}
		elseif($p[0]=='b') { // Открытие чека
			$this->b($p[1], $p[2], $p[3]);
		}
		elseif($p[0]=='smde') { // Добавление товара в чек
			// smde;НАЗВАНИЕ_ТОВАРА;ЦЕНА;КОЛВО;НАЛОГ;СЕКЦИЯ;ПСР;ППР;
			$this->smde($p[1], $p[2], $p[3], $p[4], $p[5], $p[6], $p[7]);
		}
		elseif($p[0]=='tmde') { // Оплата чека
			#tmde;СУММА;НОМЕР_ОПЛАТЫ;
        	#tmde;СУММА1;СУММА2;СУММА3;СУММА4;НОМЕР_НАЛОГА_1;НОМЕР_НАЛОГА_2;НОМЕР_НАЛОГА_3;НОМЕР_НАЛОГА_4;
			if($n==3) {
				$this->tmde_ffd_105(array($p[2]=>$p[1]), array($p[2]=>0)); // ффд 1.05
			}
			elseif($n==9) {
				$this->tmde_ffd_105(array($p[1], $p[2], $p[3], $p[4]), array($p[5], $p[6], $p[7], $p[8])); // ффд 1.05
			}
			elseif($n==7) {
				$this->tmde_ffd_11(array($p[1], $p[2], $p[3], $p[4], $p[5]), $p[6]); // ФФД 1.1
			}
			else {
				echo '<p class="false">Неверный формат переданных данных</p>';
				exit();
			}
		}
	}

	// Печать строки
	function p($strs) {
		$txts=explode('#kkm_br#', $strs);
		foreach ($txts as $t) {
			if(mb_substr($t, 0, mb_strlen('#kkm_bold#'))=='#kkm_bold#') {
               	$this->print_bold($t);
           	}
           	else {
               	$t=$this->text_format($t, $this->config['PaperWidth']);
               	$this->printer->text($t."\n");
           	}
		}
	}

	// Печать жирной строки
	function print_bold($text) {
		$this->printer->setTextSize(2, 2);
		$strs=explode('#kkm_br#', $text);
        foreach ($strs as $s) {
            $s=$this->text_format($s, floor($this->config['PaperWidth']/2));
            $this->printer->text($s."\n");
        }
		$this->printer->setTextSize(1, 1);
	}

	// Печать строки заданным шрифтом
	function print_font($text, $font) {
		$this->printer->setTextSize($font, $font);
		$strs=explode('#kkm_br#', $text);
        foreach ($strs as $s) {
            $s=$this->text_format($s, floor($this->config['PaperWidth']/$font));
            $this->printer->text($s."\n");
        }
		$this->printer->setTextSize(1, 1);
	}

	// Открытие чека
	function b($type, $cashier, $print) {
		$this->check_sum=0;
		$type_text = array("ПРОДАЖА", "ВОЗВРАТ ПРОДАЖИ", "ПОКУПКА", "ВОЗВРАТ ПОКУПКИ");
		$this->printer->setJustification(Printer::JUSTIFY_CENTER);
		$this->print_bold($type_text[$type]);
		$this->printer->setJustification(Printer::JUSTIFY_LEFT);
		$this->printer->text($cashier."\n");
	}

	// Добавление товара в чек
	function smde($title, $price, $qty, $vt, $section, $psr=null, $ppr=null) {
		$price = round($price/100, 2);
        $qty = round($qty/1000, 3);
		$summ = round($price*$qty, 2);
        $this->check_sum += $summ;
		$this->printer->text($title."\n");
		$this->printer->setJustification(Printer::JUSTIFY_RIGHT);
		$this->printer->text(number_format($qty, 3, '.', '').' x '.number_format($price, 2, ',', '')."\n");
		$this->printer->setJustification(Printer::JUSTIFY_LEFT);
		$str=$this->text_format($section."#kkm_right#≡".number_format($summ, 2, '.', ''), $this->config['PaperWidth']);
		$this->printer->text($str."\n");
	}

	// Оплаты ФФД 1.05
	function tmde_ffd_105($pays, $taxes) {
		$this->print_bold("ИТОГ#kkm_right#≡".number_format($this->check_sum, 2, '.', ''));
		$pays_methods=array('Наличными', 'Электронно', 'Картой VISA', 'Картой MasterCard');
		foreach ($pays as $key => $value) {
			if($value>0) {
				$value=round($value/100, 2);
				$str=$this->text_format($pays_methods[$key].'#kkm_right#≡'.number_format($value, 2, '.', ''), $this->config['PaperWidth']);
				$this->printer->text($str."\n");
				if($key==0 && $value>$this->check_sum) {
					$str=$this->text_format('Сдача#kkm_right#≡'.number_format($value-$this->check_sum, 2, '.', ''), $this->config['PaperWidth']);
					$this->printer->text($str."\n");
				}
			}
		}
	}

	// Оплаты ФФД 1.1
	function tmde_ffd_11($pays, $sno) {
		$this->print_bold("ИТОГ#kkm_right#≡".number_format($this->check_sum, 2, '.', ''));
		$pays_methods=array('Наличными', 'Электронно', 'Предоплата', 'Постоплата', 'Встречное предложение');
		foreach ($pays as $key => $value) {
			if($value>0) {
				$value=round($value/100, 2);
				$str=$this->text_format($pays_methods[$key].'#kkm_right#≡'.number_format($value, 2, '.', ''), $this->config['PaperWidth']);
				$this->printer->text($str."\n");
				if($key==0 && $value>$this->check_sum) {
					$str=$this->text_format('Сдача#kkm_right#≡'.number_format($value-$this->check_sum, 2, '.', ''), $this->config['PaperWidth']);
					$this->printer->text($str."\n");
				}
			}
		}
	}

	// Отправка запроса
	function send_ajax($data, $timeout=295, $view=false) {
		if(!$this->f3->get('SESSION.'.$this->sets['printer'].'_drivers_init')) {
			$this->kkm_init();
		}
		$strs=explode("\n", $data);

		$connector = $this->printer_connect();
		$this->printer = new Printer($connector);
		foreach ($strs as $s) {
			$this->wtf($s);
		}
		$this->printer -> close();
		if($view) {
			echo "Запросы отправлены";
		}
	}

}
